package de.joethei.hs.java2.praktikum.praktikum2;

import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;
import java.util.Set;

public class CharCollection implements Cloneable{

    private List<Character> list = new ArrayList<>();

    public CharCollection(char... cc) {
        for(char c:cc) this.list.add(c);
    }

    public CharCollection(String s) {
        for(char c : s.toCharArray()) {
            this.list.add(c);
        }
    }

    private CharCollection(List<Character> list) {
        this.list = list;
    }

    public int size() {
        return this.list.size();
    }

    public int count(char c) {
        int rueckgabe = 0;
        for(char b:list) {
            if(b == c)rueckgabe ++;
        }
        return rueckgabe;
    }

    public int different() {
        Set<Character> set = new HashSet<>(list);
        return set.size();
    }

    /*
    public char top() {
        if(list.size() == 0) return 0;
        ArrayList<Character> test = new ArrayList<>(list);
        Collections.sort(test);
        int actual=0, most=0;
        char top = test.get(0);
        for(char c : test) {
            if (top == c) {
                actual++;
                if (actual >= most) most = actual; top = c;
            } else {
                actual = 1;
            }
        }
        return top;
    }
    */
    public char top() {
        if(list.size() == 0) return 0;
        int max = 0;
        char character ='_';
        for(char c : list) {
            int count = count(c);
            if(count >= max) {
                character = c;
                max = count;
            }
        }
        return character;
    }

    public CharCollection moreThan(int n) {
        CharCollection result = new CharCollection(list);
        for (int i = 0; i < result.size(); i++) {
            if(result.count(result.list.get(i)) < n) result.list.remove(i);
        }
        return result;
    }

    @Override
    public String toString() {
        return list.toString().replace('[', '(').replace(']', ')');
    }

    @Override
    public boolean equals(Object o) {
        if(o instanceof CharCollection) {
            CharCollection c = (CharCollection) o;
            return this.list.containsAll(c.list);
        }return false;
    }

}